import ExtractTextPlugin from 'extract-text-webpack-plugin'

export default config => {
  return {
    output: {
      filename: '[name].js',
      sourceMapFilename: '[name].map'
    },

    devtool: 'inline-source-map',

    module: {
      rules: [
        {
          test: /\.css$/,
          use: ExtractTextPlugin.extract({
            fallback: 'style-loader',
            use: [
              { loader: 'css-loader' },
              {
                loader: 'postcss-loader',
                options: {
                  plugins: () => {
                    return config.postcssOptions
                  }
                }
              }
            ]
          })
        }
      ]
    },

    plugins: [
      new ExtractTextPlugin({
        filename: '[name].css'
      })
    ]
  }
}
